2 # SPDX-License-Identifier: GPL-2.0
4 # Tests whether a suitable Rust toolchain is available.
8 min_tool_version=$(dirname $0)/min-tool-version.sh
10 # Convert the version string x.y.z to a canonical up-to-7-digits form.
12 # Note that this function uses one more digit (compared to other
13 # instances in other version scripts) to give a bit more space to
14 # `rustc` since it will reach 1.100.0 in late 2026.
15 get_canonical_version()
19 echo $((100000 * $1 + 100 * $2 + $3))
22 # Check that the Rust compiler exists.
23 if ! command -v "$RUSTC" >/dev/null; then
25 echo >&2 "*** Rust compiler '$RUSTC' could not be found."
30 # Check that the Rust bindings generator exists.
31 if ! command -v "$BINDGEN" >/dev/null; then
33 echo >&2 "*** Rust bindings generator '$BINDGEN' could not be found."
38 # Check that the Rust compiler version is suitable.
40 # Non-stable and distributions' versions may have a version suffix, e.g. `-dev`.
41 rust_compiler_version=$( \
42 LC_ALL=C "$RUSTC" --version 2>/dev/null \
44 | grep -oE '[0-9]+\.[0-9]+\.[0-9]+' \
46 rust_compiler_min_version=$($min_tool_version rustc)
47 rust_compiler_cversion=$(get_canonical_version $rust_compiler_version)
48 rust_compiler_min_cversion=$(get_canonical_version $rust_compiler_min_version)
49 if [ "$rust_compiler_cversion" -lt "$rust_compiler_min_cversion" ]; then
51 echo >&2 "*** Rust compiler '$RUSTC' is too old."
52 echo >&2 "*** Your version: $rust_compiler_version"
53 echo >&2 "*** Minimum version: $rust_compiler_min_version"
57 if [ "$rust_compiler_cversion" -gt "$rust_compiler_min_cversion" ]; then
59 echo >&2 "*** Rust compiler '$RUSTC' is too new. This may or may not work."
60 echo >&2 "*** Your version: $rust_compiler_version"
61 echo >&2 "*** Expected version: $rust_compiler_min_version"
65 # Check that the Rust bindings generator is suitable.
67 # Non-stable and distributions' versions may have a version suffix, e.g. `-dev`.
68 rust_bindings_generator_version=$( \
69 LC_ALL=C "$BINDGEN" --version 2>/dev/null \
71 | grep -oE '[0-9]+\.[0-9]+\.[0-9]+' \
73 rust_bindings_generator_min_version=$($min_tool_version bindgen)
74 rust_bindings_generator_cversion=$(get_canonical_version $rust_bindings_generator_version)
75 rust_bindings_generator_min_cversion=$(get_canonical_version $rust_bindings_generator_min_version)
76 if [ "$rust_bindings_generator_cversion" -lt "$rust_bindings_generator_min_cversion" ]; then
78 echo >&2 "*** Rust bindings generator '$BINDGEN' is too old."
79 echo >&2 "*** Your version: $rust_bindings_generator_version"
80 echo >&2 "*** Minimum version: $rust_bindings_generator_min_version"
84 if [ "$rust_bindings_generator_cversion" -gt "$rust_bindings_generator_min_cversion" ]; then
86 echo >&2 "*** Rust bindings generator '$BINDGEN' is too new. This may or may not work."
87 echo >&2 "*** Your version: $rust_bindings_generator_version"
88 echo >&2 "*** Expected version: $rust_bindings_generator_min_version"
92 # Check that the `libclang` used by the Rust bindings generator is suitable.
94 # In order to do that, first invoke `bindgen` to get the `libclang` version
95 # found by `bindgen`. This step may already fail if, for instance, `libclang`
96 # is not found, thus inform the user in such a case.
97 bindgen_libclang_output=$( \
98 LC_ALL=C "$BINDGEN" $(dirname $0)/rust_is_available_bindgen_libclang.h 2>&1 >/dev/null
99 ) || bindgen_libclang_code=$?
100 if [ -n "$bindgen_libclang_code" ]; then
102 echo >&2 "*** Running '$BINDGEN' to check the libclang version (used by the Rust"
103 echo >&2 "*** bindings generator) failed with code $bindgen_libclang_code. This may be caused by"
104 echo >&2 "*** a failure to locate libclang. See output and docs below for details:"
106 echo >&2 "$bindgen_libclang_output"
111 # `bindgen` returned successfully, thus use the output to check that the version
112 # of the `libclang` found by the Rust bindings generator is suitable.
113 bindgen_libclang_version=$( \
114 echo "$bindgen_libclang_output" \
115 | sed -nE 's:.*clang version ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
117 bindgen_libclang_min_version=$($min_tool_version llvm)
118 bindgen_libclang_cversion=$(get_canonical_version $bindgen_libclang_version)
119 bindgen_libclang_min_cversion=$(get_canonical_version $bindgen_libclang_min_version)
120 if [ "$bindgen_libclang_cversion" -lt "$bindgen_libclang_min_cversion" ]; then
122 echo >&2 "*** libclang (used by the Rust bindings generator '$BINDGEN') is too old."
123 echo >&2 "*** Your version: $bindgen_libclang_version"
124 echo >&2 "*** Minimum version: $bindgen_libclang_min_version"
129 # If the C compiler is Clang, then we can also check whether its version
130 # matches the `libclang` version used by the Rust bindings generator.
132 # In the future, we might be able to perform a full version check, see
133 # https://github.com/rust-lang/rust-bindgen/issues/2138.
134 cc_name=$($(dirname $0)/cc-version.sh $CC | cut -f1 -d' ')
135 if [ "$cc_name" = Clang ]; then
137 LC_ALL=C $CC --version 2>/dev/null \
138 | sed -nE '1s:.*version ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
140 if [ "$clang_version" != "$bindgen_libclang_version" ]; then
142 echo >&2 "*** libclang (used by the Rust bindings generator '$BINDGEN')"
143 echo >&2 "*** version does not match Clang's. This may be a problem."
144 echo >&2 "*** libclang version: $bindgen_libclang_version"
145 echo >&2 "*** Clang version: $clang_version"
150 # Check that the source code for the `core` standard library exists.
152 # `$KRUSTFLAGS` is passed in case the user added `--sysroot`.
153 rustc_sysroot=$("$RUSTC" $KRUSTFLAGS --print sysroot)
154 rustc_src=${RUST_LIB_SRC:-"$rustc_sysroot/lib/rustlib/src/rust/library"}
155 rustc_src_core="$rustc_src/core/src/lib.rs"
156 if [ ! -e "$rustc_src_core" ]; then
158 echo >&2 "*** Source code for the 'core' standard library could not be found"
159 echo >&2 "*** at '$rustc_src_core'."